//----------------
//Variable Events
//Creator: Destiny
//Helpers:
//Chrono
//Truce
//Clockturn/M
//----------------
//Main
//----------------
function VCE_initServer()
{
	$VCE::Server = 1;
	registerOutputEvent(fxDtsBrick,"VCE_modVariable","list Brick 0 Player 1 Client 2\tstring 32 100\tlist Set 0 Add 1 Subtract 2 Multiply 3 Divide 4 Modular 5 Floor 6 Ceil 7 Power 8 SquareRoot 9 Percent 10 RandomNum 11\tstring 32 100",1);
	registerOutputEvent(fxDtsBrick,"VCE_ifValue","string 100 100\tlist == 0 != 1 > 2 < 3 >= 4 <= 5\tstring 100 100\tstring 8 30",1);
	registerOutputEvent(fxDtsBrick,"VCE_ifVariable","string 100 100\tlist == 0 != 1 > 2 < 3 >= 4 <= 5\tstring 50 50\tstring 8 30",1);
	registerOutputEvent(Player,"VCE_ifVariable","string 100 100\tlist == 0 != 1 > 2 < 3 >= 4 <= 5\tstring 50 50\tstring 8 30",1);
	registerOutputEvent(GameConnection,"VCE_ifVariable","string 100 100\tlist == 0 != 1 > 2 < 3 >= 4 <= 5\tstring 50 50\tstring 8 30",1);
	ActivatePackage(VCE_Main);
	RegisterInputEvent(fxDtsBrick,"onVariableTrue","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
	RegisterInputEvent(fxDtsBrick,"onVariableFalse","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");

	RegisterSpecialVar(GameConnection,"bl_id","%this.bl_id");
	RegisterSpecialVar(GameConnection,"name","%this.getPlayerName()");
	RegisterSpecialVar(GameConnection,"score","%this.score");
	RegisterSpecialVar(GameConnection,"lastmsg","%this.lastMessage");
	RegisterSpecialVar(GameConnection,"lastteammsg","%this.lastTeamMessage");
	RegisterSpecialVar(GameConnection,"isAdmin","%this.isAdmin");
	RegisterSpecialVar(GameConnection,"isSuperAdmin","%this.isSuperAdmin");
	RegisterSpecialVar(Player,"damage","%this.getDamageLevel()");
	RegisterSpecialVar(Player,"health","%this.getDatablock().maxDamage - %this.getDamageLevel()");
	RegisterSpecialVar(Player,"maxhealth","%this.getDatablock().maxDamage");
	RegisterSpecialVar(Player,"velx","getWord(%this.getVelocity(),0)");
	RegisterSpecialVar(Player,"vely","getWord(%this.getVelocity(),1)");
	RegisterSpecialVar(Player,"velz","getWord(%this.getVelocity(),2)");
	RegisterSpecialVar(Player,"crouching","%this.crouch");
	RegisterSpecialVar(Player,"jumping","%this.jump");
	RegisterSpecialVar(Player,"jetting","%this.jet");
	RegisterSpecialVar(Player,"firing","%this.fire");
	RegisterSpecialVar(Player,"datablock","%this.getDatablock().getName()");
	RegisterSpecialVar(fxDTSbrick,"colorid","%this.getColorID()");
	RegisterSpecialVar(fxDTSbrick,"printcount","%this.printcount");
	RegisterSpecialVar(fxDTSbrick,"colorfxid","%this.getColorFXID()");
	RegisterSpecialVar(fxDTSbrick,"shapefxid","%this.getShapeFXID()");
}
//----------------
//Package
//----------------
package VCE_Main
{
	function fxDtsBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);
		if(!isObject(getVariableGroupFromObject(%brick)))
		{
			VCE_createVariableGroup(%brick);
		}
	}
	function fxDtsBrick::processInputEvent(%brick,%event,%client)
	{
		%client.processingBrick = %brick;
		Parent::processInputEvent(%brick,%event,%client);
	}
	function GameConnection::ChatMessage(%c,%msg)
	{
		%msg = filterVariableString(%msg,$inputTarget_self,%c,%c.player);
		Parent::ChatMessage(%c,%msg);
	}
	function GameConnection::CenterPrint(%c,%msg,%time)
	{
		%msg = filterVariableString(%msg,$inputTarget_self,%c,%c.player);
		Parent::CenterPrint(%c,%msg,%time);
	}
	function GameConnection::BottomPrint(%c,%msg,%time)
	{
		%msg = filterVariableString(%msg,$inputTarget_self,%c,%c.player);
		Parent::BottomPrint(%c,%msg,%time);
	}
	function MiniGameSO::BottomPrintAll(%mg,%msg,%time)
	{
		for(%i=0;%i<%mg.nummembers;%i++)
		{
			%nmsg = filterVariableString(%msg,$inputTarget_Self,%mg.member[%i],%mg.member[%i].player);
			commandtoclient(%mg.member[%i],'bottomprint',%nmsg,%time,%time);
		}
	}
	function MiniGameSO::CenterPrintAll(%mg,%msg,%time)
	{
		for(%i=0;%i<%mg.nummembers;%i++)
		{
			%nmsg = filterVariableString(%msg,$inputTarget_Self,%mg.member[%i],%mg.member[%i].player);
			commandtoclient(%mg.member[%i],'centerprint',%nmsg,%time,%time);
		}
	}
	function MiniGameSO::ChatMsgAll(%mg,%msg,%client)
	{
		for(%i=0;%i<%mg.nummembers;%i++)
		{
			%nmsg = filterVariableString(%msg,$inputTarget_Self,%mg.member[%i],%mg.member[%i].player);
			messageclient(%mg.member[%i],'',%nmsg,%client.getPlayerName());
		}
	}
	function servercmdmessagesent(%client,%message)
	{
		%client.lastMessage = %message;
		Parent::servercmdmessagesent(%client,%message);
	}
	function servercmdteammessagesent(%client,%message)
	{
		%client.lastTeamMessage = %message;
		Parent::servercmdteammessagesent(%client,%message);
	}
	function Armor::onTrigger(%datablock,%player,%slot,%val)
	{
		Parent::onTrigger(%datablock,%player,%slot,%val);
		switch(%slot)
		{
		case 0:
			%player.fire = %val;
		case 2:
			%player.jump = %val;
		case 3:
			%player.crouch = %val;
		case 4:
			%player.jet = %val;
		}
	}
};
//----------------
//Variable Value Filters & Misc Functions
//----------------
function mPercent(%num,%total)
{
	return (%num / %total)*100;
}
function isInt(%string)
{
	return %string $= mFloatLength(%string, 0);
}
function serverCmdBlockVCEByID(%client,%BLID)
{
	if(%BLID $= "" || !isInt(%BLID))
	{
		return;
	}
	switch(%client.blockVCE[%BLID])
	{
		case 0:
			%client.blockVCE[%BLID] = true;
			messageClient(%client,'','\c6You are now blocking the ID \c0%1\c6 from using any variable events on you.',%BLID);
		case 1:
			%client.blockVCE[%BLID] = false;
			messageClient(%client,'','\c6You are no longer blocking the ID \c0%1\c6 from using any variable events on you.',%BLID);
	}
}
function filterVariableString(%string,%brick,%client,%player)
{
	if(!isObject(%brick) || !isObject(%client) || !isObject(%player) || %client.blockVCE[getBrickGroupFromObject(%brick).bl_id] == true)
	{
		return;
	}
	%offset = 0;
	%its = 0;
	while(1)
	{
		%open = strpos(%string,"<var:",%offset);
		if(%open == -1)
		{
			break;
		}
		%close = strpos(%string,">",%open);
		%varstr = getsubstr(%string,%open+1,(%close-%open)-1);
		%varlen = strlen(%varstr)+2;
		%varstr = getsubstr(%varstr,4,strlen(%varstr)-4);
		%colon = strpos(%varstr,":");
		%mode = getsubstr(%varstr,0,%colon);
		%var = getsubstr(%varstr,%colon+1,strlen(%varstr));
		switch$(%mode)
		{
		case "client":
			if($SpecialVar["GameConnection",%var] $= "")
			{
				%variable = %brick.getGroup().vargroup.getVariable("Client",%var,%client);
			} else {
				%variable = eval("return" SPC strreplace($SpecialVar["GameConnection",%var],"%this",%client) @ ";");
			}
			%string = getsubstr(%string,0,%open) @ %variable @ getsubstr(%string,%close+1,strlen(%string));
		case "player":
			if($SpecialVar["Player",%var] $= "")
			{
				%variable = %brick.getGroup().vargroup.getVariable("Player",%var,%player);
			} else {
				%variable = eval("return" SPC strreplace($SpecialVar["Player",%var],"%this",%player) @ ";");
			}
			%string = getsubstr(%string,0,%open) @ %variable @ getsubstr(%string,%close+1,strlen(%string));
		case "brick":
			if($SpecialVar["fxDTSbrick",%var] $= "")
			{
				%variable = %brick.getGroup().vargroup.getVariable("Brick",%var,%brick);
			} else {
				%variable = eval("return" SPC strreplace($SpecialVar["fxDTSbrick",%var],"%this",%brick) @ ";");
			}
			%string = getsubstr(%string,0,%open) @ %variable @ getsubstr(%string,%close+1,strlen(%string));
		case "cl":
			if($SpecialVar["GameConnection",%var] $= "")
			{
				%variable = %brick.getGroup().vargroup.getVariable("Client",%var,%client);
			} else {
				%variable = eval("return" SPC strreplace($SpecialVar["GameConnection",%var],"%this",%client) @ ";");
			}
			%string = getsubstr(%string,0,%open) @ %variable @ getsubstr(%string,%close+1,strlen(%string));
		case "pl":
			if($SpecialVar["Player",%var] $= "")
			{
				%variable = %brick.getGroup().vargroup.getVariable("Player",%var,%player);
			} else {
				%variable = eval("return" SPC strreplace($SpecialVar["Player",%var],"%this",%player) @ ";");
			}
			%string = getsubstr(%string,0,%open) @ %variable @ getsubstr(%string,%close+1,strlen(%string));
		case "br":
			if($SpecialVar["fxDTSbrick",%var] $= "")
			{
				%variable = %brick.getGroup().vargroup.getVariable("Brick",%var,%brick);
			} else {
				%variable = eval("return" SPC strreplace($SpecialVar["fxDTSbrick",%var],"%this",%brick) @ ";");
			}
			%string = getsubstr(%string,0,%open) @ %variable @ getsubstr(%string,%close+1,strlen(%string));
		}
		%offset += strlen(%variable);
		%its++;
		if(%its > 15)
		{
			break;
		}
	}
	return %string;
}
function RegisterSpecialVar(%classname,%name,%script)
{
	if($SpecialVar[%classname,%name] !$= "")
	{
		echo("RegisterSpecialVar() - Variable" SPC %name SPC "already exists on" SPC %classname @ ". Overwriting...");
	}
	$SpecialVar[%classname,%name] = %script;
}
function RegisterModVar(%name,%script)
{
	if($modVar[%name] !$= "")
	{
		echo("RegisterModVar() - Mod function " SPC %name SPC "already exists. Overwriting...");
	}
	$modVar[%name] = %script;
	$modVarID[$ModVarIDCount] = %name;
	$ModVarIDCount++;
}
//----------------
//Variable Groups
//----------------
function getVariableGroupFromObject(%obj)
{
	switch$(%obj.getClassName())
	{
		case "Player":
			%vargroup = nameToID("VariableGroup_"@%obj.client.BL_ID);
		case "fxDtsBrick":
			%vargroup = nameToID("VariableGroup_"@%obj.getGroup().BL_ID);
		case "GameConnection":
			%vargroup = nameToID("VariableGroup_"@%obj.BL_ID);
		case "MinigameSO":
			%vargroup = nameToID("VariableGroup_"@%obj.owner.BL_ID);
	}
	if(isObject(%vargroup))
	{
		return %vargroup;
	}
	return 0;
}
function VCE_createVariableGroup(%brick)
{
	%brickgroup = getBrickGroupFromObject(%brick);
	if(isObject(%brickgroup))
	{
		if(!isObject(%brickgroup.vargroup) && %brickgroup.bl_id !$= "")
		{
			%brickgroup.vargroup = new ScriptObject("VariableGroup_"@%brickgroup.bl_id)
			{
				class = "VariableGroup";
			};
			%brickgroup.vargroup.bl_id = %brickgroup.bl_id;
			%brickgroup.vargroup.name = %brickgroup.name;
			%brickgroup.vargroup.client = %brickgroup.client;
		}
	}
}
function VariableGroup::setVariable(%group,%type,%name,%value,%obj)
{
	if(!isObject(%group))
	{
		return;
	}
	if($SpecialVar[%obj.getClassName(),%name] !$= "")
	{
		return;
	}
	%group.value[%type,%obj,%name] = %value;
}
function VariableGroup::getVariable(%group,%type,%name,%obj)
{
	if(!isObject(%group))
	{
		return;
	}
	if($SpecialVar[%obj.getClassName(),%name] !$= "")
	{
		return;
	}
	return %group.value[%type,%obj,%name];
}
//----------------
//Events
//----------------
function fxDtsBrick::VCE_modVariable(%brick,%type,%name,%logic,%value,%client)
{
	if(%client.blockVCE[getBrickGroupFromObject(%brick).bl_id] == true)
	{
		return;
	}
	if(isObject(%brick.getGroup().vargroup))
	{
		switch(%type)
		{
			case 0:
				%category = "Brick";
				%target = %brick;
			case 1:
				%category = "Player";
				%target = %client.player;
			case 2:
				%category = "Client";
				%target = %client;
		}
		%oldvalue = %brick.getGroup().vargroup.getVariable(%category,%name,%target);
		%newvalue = filterVariableString(%value,%brick,%client,%client.player);
		switch(%logic)
		{
			case 1:
				%brick.getGroup().vargroup.setVariable(%category,%name,%oldvalue + %newvalue,%target);
			case 2:
				%brick.getGroup().vargroup.setVariable(%category,%name,%oldvalue - %newvalue,%target);
			case 3:
				%brick.getGroup().vargroup.setVariable(%category,%name,%oldvalue * %newvalue,%target);
			case 4:
				%brick.getGroup().vargroup.setVariable(%category,%name,%oldvalue / %newvalue,%target);
			case 5:
				%brick.getGroup().vargroup.setVariable(%category,%name,%oldvalue % %newvalue,%target);
			case 6:
				%brick.getGroup().vargroup.setVariable(%category,%name,mFloor(%oldvalue),%target);
			case 7:
				%brick.getGroup().vargroup.setVariable(%category,%name,mCeil(%oldvalue),%target);
			case 0:
				%brick.getGroup().vargroup.setVariable(%category,%name,%newvalue,%target);
			case 8:
				%brick.getGroup().vargroup.setVariable(%category,%name,mPow(%oldvalue,%newvalue),%target);
			case 9:
				%brick.getGroup().vargroup.setVariable(%category,%name,mSqrt(%oldvalue),%target);
			case 10:
				%brick.getGroup().vargroup.setVariable(%category,%name,mPercent(%oldvalue,%newvalue),%target);
			case 11:
				if(isInt(%oldvalue) && isInt(%newvalue))
				{
					%brick.getGroup().vargroup.setVariable(%category,%name,getRandom(%oldvalue,%newvalue),%target);
				}
		}
	}
}
function Player::VCE_ifVariable(%player,%var,%logic,%valb,%subdata,%client)
{
	%brick = %client.processingBrick;
	if(%client.blockVCE[getBrickGroupFromObject(%brick).bl_id] == true)
	{
		return;
	}
	if(isObject(%brick.getGroup().vargroup))
	{
		%vala = %brick.getGroup().vargroup.getVariable("Player",%var,%player);
		%valb = strReplace(%valb,";","");
		%valb = filterVariableString(%valb,%brick,%client,%client.player);
		%substart = getWord(%subdata,0);
		%subend = getWord(%subdata,1);
		switch(%logic)
		{
			case 0:
				%test = %vala $= %valb;
			case 1:
				%test = %vala !$= %valb;
			case 2:
				%test = %vala > %valb;
			case 3:
				%test = %vala < %valb;
			case 4:
				%test = %vala >= %valb;
			case 5:
				%test = %vala <= %valb;
		}
		$inputTarget_Self = %brick;
		$inputTarget_Player = %client.player;
		$inputTarget_Client = %client;
		$inputTarget_Minigame = getMinigameFromObject(%client);
		if(%substart $= "" || %subend $= "" || !isInt(%substart) || !isInt(%subend) || %substart < 0 || %subend > %brick.numEvents)
		{
			if(%test)
			{
				%brick.processInputEvent("onVariableTrue",%client);
				return;
			} 
			else 
			{
				%brick.processInputEvent("onVariableFalse",%client);
				return;
			}
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(!(%i >= %substart && %i <= %subend))
			{
				if(%brick.eventInput[%i] $= "onVariableTrue" || %brick.eventInput[%i] $= "onVariableFalse")
				{
					%oldEnabled[%i] = %brick.eventEnabled[%i];
					%brick.eventEnabled[%i] = 0;
				}
			}
		}
		if(%test)
		{
			%brick.processInputEvent("onVariableTrue",%client);
		} else {
			%brick.processInputEvent("onVariableFalse",%client);
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(%oldEnabled[%i] !$= "")
			{
				%brick.eventEnabled[%i] = %oldEnabled[%i];
			}
		}
	}
}
function GameConnection::VCE_ifVariable(%client,%var,%logic,%valb,%subdata,%clientb)
{
	%brick = %client.processingBrick;
	if(%client.blockVCE[getBrickGroupFromObject(%brick).bl_id] == true)
	{
		return;
	}
	if(isObject(%brick.getGroup().vargroup))
	{
		%vala = %brick.getGroup().vargroup.getVariable("Client",%var,%client);
		%valb = strReplace(%valb,";","");
		%valb = filterVariableString(%valb,%brick,%client,%client.player);
		%substart = getWord(%subdata,0);
		%subend = getWord(%subdata,1);
		switch(%logic)
		{
			case 0:
				%test = %vala $= %valb;
			case 1:
				%test = %vala !$= %valb;
			case 2:
				%test = %vala > %valb;
			case 3:
				%test = %vala < %valb;
			case 4:
				%test = %vala >= %valb;
			case 5:
				%test = %vala <= %valb;
		}
		$inputTarget_Self = %brick;
		$inputTarget_Player = %client.player;
		$inputTarget_Client = %client;
		$inputTarget_Minigame = getMinigameFromObject(%client);
		if(%substart $= "" || %subend $= "" || !isInt(%substart) || !isInt(%subend) || %substart < 0 || %subend > %brick.numEvents)
		{
			if(%test)
			{
				%brick.processInputEvent("onVariableTrue",%client);
				return;
			} 
			else 
			{
				%brick.processInputEvent("onVariableFalse",%client);
				return;
			}
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(!(%i >= %substart && %i <= %subend))
			{
				if(%brick.eventInput[%i] $= "onVariableTrue" || %brick.eventInput[%i] $= "onVariableFalse")
				{
					%oldEnabled[%i] = %brick.eventEnabled[%i];
					%brick.eventEnabled[%i] = 0;
				}
			}
		}
		if(%test)
		{
			%brick.processInputEvent("onVariableTrue",%client);
		} else {
			%brick.processInputEvent("onVariableFalse",%client);
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(%oldEnabled[%i] !$= "")
			{
				%brick.eventEnabled[%i] = %oldEnabled[%i];
			}
		}
	}
}
function fxDtsBrick::VCE_ifVariable(%brick,%var,%logic,%valb,%subdata,%client)
{
	if(%client.blockVCE[getBrickGroupFromObject(%brick).bl_id] == true)
	{
		return;
	}
	if(isObject(%brick.getGroup().vargroup))
	{
		%vala = %brick.getGroup().vargroup.getVariable("Brick",%var,%brick);
		%valb = strReplace(%valb,";","");
		%valb = filterVariableString(%valb,%brick,%client,%client.player);
		%substart = getWord(%subdata,0);
		%subend = getWord(%subdata,1);
		switch(%logic)
		{
			case 0:
				%test = %vala $= %valb;
			case 1:
				%test = %vala !$= %valb;
			case 2:
				%test = %vala > %valb;
			case 3:
				%test = %vala < %valb;
			case 4:
				%test = %vala >= %valb;
			case 5:
				%test = %vala <= %valb;
		}
		$inputTarget_Self = %brick;
		$inputTarget_Player = %client.player;
		$inputTarget_Client = %client;
		$inputTarget_Minigame = getMinigameFromObject(%client);
		if(%substart $= "" || %subend $= "" || !isInt(%substart) || !isInt(%subend) || %substart < 0 || %subend > %brick.numEvents)
		{
			if(%test)
			{
				%brick.processInputEvent("onVariableTrue",%client);
				return;
			} 
			else 
			{
				%brick.processInputEvent("onVariableFalse",%client);
				return;
			}
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(!(%i >= %substart && %i <= %subend))
			{
				if(%brick.eventInput[%i] $= "onVariableTrue" || %brick.eventInput[%i] $= "onVariableFalse")
				{
					%oldEnabled[%i] = %brick.eventEnabled[%i];
					%brick.eventEnabled[%i] = 0;
				}
			}
		}
		if(%test)
		{
			%brick.processInputEvent("onVariableTrue",%client);
		} else {
			%brick.processInputEvent("onVariableFalse",%client);
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(%oldEnabled[%i] !$= "")
			{
				%brick.eventEnabled[%i] = %oldEnabled[%i];
			}
		}
	}
}
function fxDtsBrick::VCE_ifValue(%brick,%vala,%logic,%valb,%subdata,%client)
{
	if(%client.blockVCE[getBrickGroupFromObject(%brick).bl_id] == true)
	{
		return;
	}
	if(isObject(%brick.getGroup().vargroup))
	{
		%vala = strReplace(%vala,";","");
		%vala = filterVariableString(%vala,%brick,%client,%client.player);
		%valb = strReplace(%valb,";","");
		%valb = filterVariableString(%valb,%brick,%client,%client.player);
		%substart = getWord(%subdata,0);
		%subend = getWord(%subdata,1);
		switch(%logic)
		{
			case 0:
				%test = %vala $= %valb;
			case 1:
				%test = %vala !$= %valb;
			case 2:
				%test = %vala > %valb;
			case 3:
				%test = %vala < %valb;
			case 4:
				%test = %vala >= %valb;
			case 5:
				%test = %vala <= %valb;
		}
		$inputTarget_Self = %brick;
		$inputTarget_Player = %client.player;
		$inputTarget_Client = %client;
		$inputTarget_Minigame = getMinigameFromObject(%client);
		if(%substart $= "" || %subend $= "" || !isInt(%substart) || !isInt(%subend) || %substart < 0 || %subend > %brick.numEvents)
		{
			if(%test)
			{
				%brick.processInputEvent("onVariableTrue",%client);
				return;
			} 
			else 
			{
				%brick.processInputEvent("onVariableFalse",%client);
				return;
			}
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(!(%i >= %substart && %i <= %subend))
			{
				if(%brick.eventInput[%i] $= "onVariableTrue" || %brick.eventInput[%i] $= "onVariableFalse")
				{
					%oldEnabled[%i] = %brick.eventEnabled[%i];
					%brick.eventEnabled[%i] = 0;
				}
			}
		}
		if(%test)
		{
			%brick.processInputEvent("onVariableTrue",%client);
		} else {
			%brick.processInputEvent("onVariableFalse",%client);
		}
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(%oldEnabled[%i] !$= "")
			{
				%brick.eventEnabled[%i] = %oldEnabled[%i];
			}
		}
	}
}
$VCE::InitSchedule = schedule(2000,0,"VCE_initServer");